
/**
 *  Fixes für andere Erweiterungen
 *      => Aufruf durch aios_initSidebar() in aios.js
 **/
function aios_improveCompatibility() {   
    // Optimoz-Tweaks
    if(document.getElementById('moztweaksBundle')) {
        aios_optimozTweaksMode(true);
        window.setTimeout("aios_optimozTweaksMode(true)", 300);
    }
	
    // Console2
    if(document.getElementById('viewConsole2Sidebar')) {
        window.setTimeout("aios_modConsole2()", 300);
    }
	
    // MinimizeToTray
    if(document.getElementById('extensions.mook.minimizetotray.traypopup')) {
        aios_modMinimizeToTray();
    }
    
    // MileWideBack
    // wird in aios.js => aios_setSidebarOrient() ausgefuehrt
    
    // StumbleUpon
    if(document.getElementById('su_splitter_first')) {
        document.getElementById('su_splitter_first').style.display = "none";
    }
    
    // Autohide
    if(typeof autoHIDE == "object") {
        aios_Autohide();
    }
}


/**
 *  Anpassungen für MinimizeToTray (sonst öffnet sich der Download-Manager nicht bei Aufruf über das Trayicon)
 *      => Aufruf durch aios_improveCompatibility()
 **/
function aios_modMinimizeToTray() {
	
    var mmttMenuItems = document.getElementById('extensions.mook.minimizetotray.traypopup').childNodes;
    var itemCmd;
	
    for(var i = 0; i < mmttMenuItems.length; i++) {
        itemCmd = mmttMenuItems[i].getAttribute('oncommand');
        if(itemCmd.indexOf("toOpenWindowByType('Download:Manager'") >= 0) {
            var newCmd = 'aios_WIN.aiosIsWindow = true; window.setTimeout("aios_WIN.aiosIsWindow=false;", 500);' + itemCmd;
            mmttMenuItems[i].setAttribute('oncommand', newCmd);
        }
    }
	
    return true;
}


/**
 *  Console2-Anpassungen
 *      => Aufruf durch aios_improveCompatibility()
 **/
function aios_modConsole2() {
	
    // meinen Sidebar-Menü-Eintrag der Console2 zuweisen
    document.getElementById('console-mitem').setAttribute('observes', 'viewConsole2Sidebar');

    // meinen Broadcaster löschen > keine Auswahlmöglichkeit in den Prefs
    if(document.getElementById('viewConsoleSidebar')) {
        var consoleBroad = document.getElementById('viewConsoleSidebar');
        consoleBroad.parentNode.removeChild(consoleBroad);
    }

    // Console2-Button
    var coButton = document.getElementById('console2-button');
    if(coButton) {
        if(coButton.parentNode.tagName == "toolbarpaletteitem")
            coButton.parentNode.parentNode.removeChild(coButton.parentNode);
        else coButton.parentNode.removeChild(coButton);
    }
	
    return true;
}


/**
 *  Optimoz-Tweaks-Anapssungen
 *      => Aufruf durch aios_improveCompatibility()
 **/
function aios_optimozTweaksMode(mode) {
	
    aios_getObjects();

    // 	=> bei jedem MouseOver nötig, weil sich die Einstellungen von OptiMoz geändert haben könnten
    if(mode == true) {
        aios_toggleBox.addEventListener("mouseover", aios_optimozTweaksMode, false);
        aiostbx_left_toolbox.addEventListener("mouseover", aios_optimozTweaksMode, false);
    }
    else {
        try {
            var hidemethod = aios_gPref.getIntPref('moztweaks.sidebar.hidemethod');
        }
        catch(e) { }

        // 	=> Event-Listener entfernen und hinzufügen
        if(hidemethod == 0) {
            aios_toggleBox.removeEventListener("mousemove", mtSidebarMouseMoveListener, false);
            aios_toggleBox.addEventListener("mousemove", mtMouseMoveListener, false);
            aios_toggleBox.addEventListener("mousemove", mtPreventHiding, true);

            aiostbx_left_toolbox.removeEventListener("mousemove", mtSidebarMouseMoveListener, false);
            aiostbx_left_toolbox.addEventListener("mousemove", mtMouseMoveListener, false);
            aiostbx_left_toolbox.addEventListener("mousemove", mtPreventHiding, true);
        }
        else if(hidemethod == 1) {
            aios_toggleBox.removeEventListener("mousemove", mtMouseMoveListener, false);
            aios_toggleBox.removeEventListener("mousemove", mtPreventHiding, false);
            aios_toggleBox.addEventListener("mousemove", mtSidebarMouseMoveListener, false);

            aiostbx_left_toolbox.removeEventListener("mousemove", mtMouseMoveListener, false);
            aiostbx_left_toolbox.removeEventListener("mousemove", mtPreventHiding, false);
            aiostbx_left_toolbox.addEventListener("mousemove", mtSidebarMouseMoveListener, false);
        }
    }

    return true;
}


/**
 *  Autohide-Anapssungen
 *      => Aufruf durch aios_improveCompatibility()
 *      => wenn das Attribut 'fullscreentoolbar' immer verwendet würde, würde ohne Autohide der Switch und die Toolbar immer ausgeblendet
 **/
function aios_Autohide() {
	
    aios_getObjects();
	
    aios_toggleBar.setAttribute('fullscreentoolbar', 'true');
    aios_toolbar.setAttribute('fullscreentoolbar', 'true');
}