
/**
 *  All functions below are modified from native Fx Customize code in
 *  ../toolkit/customizeToolbar.js, as of changeset:
 *
 *  40690e93dfc0 2009-06-22 20:29 +0800.
 *
 *  The major changes are to wrap functions in a for(){} loop to handle multiple
 *  toolboxes, to change the reference from the single gToolbox to multiple
 *  toolbox elements within the loop.
 */

/**
 *  All functions taken from TotalToolbar 1.7 by alta88
 */

var navToolbox, gToolboxes, winDoc, gStatusbar, gStatusbarMode;

// Icons im Konfigurationsfenster anzeigen
if(parseFloat(aios_appVersion) <= 3.6 && aios_appDefTheme && aios_appOS == "Darwin") aios_addCSS("aios_theme_darwin.css", "CustomizeToolbarWindow");

InitWithToolbox = function (aToolbox) {
    // Get the navToolbox (original toolbox, containing defaults).
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
    .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    gStatusbar = win.document.getElementById("status-bar");
    navToolbox = win.gNavToolbox; //getNavToolbox();

    if (gToolboxSheet) {
        // Note: if gToolboxSheet (customize dialog in an iframe) then aToolbox is
        // our array, as there won't be a window; make gToolbox be the navToolbox.
        gToolbox = navToolbox;
        gToolboxes = aToolbox;
        winDoc = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
        .getInterface(Components.interfaces.nsIWebNavigation)
        .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
        .rootTreeItem
        .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
        .getInterface(Components.interfaces.nsIDOMWindow)
        .document;
    }
    else {
        // Pass the full array of toolboxes as the 2nd argument so as not to
        // break any other xul app (extension) using customisable toolbars.
        gToolbox = aToolbox;
        gToolboxes = (window.arguments && window.arguments.length > 1) ?
        window.arguments[1] : [aToolbox];
        winDoc = window.opener.top.document;
    }

    gStatusbarMode = gToolboxes[0].localName == "statusbar" ? true : false;
    gToolboxDocument = gToolbox.ownerDocument;

    for(var i = 0; i < gToolboxes.length; i++) {
        gToolboxes[i].addEventListener("dragstart", onToolbarDragStart, false);
        gToolboxes[i].addEventListener("dragover", onToolbarDragOver, false);
        gToolboxes[i].addEventListener("dragleave", onToolbarDragLeave, false);
        gToolboxes[i].addEventListener("drop", onToolbarDrop, false);
        // For css styling of min-width etc.
        gToolboxes[i].customizing = true;
    }

    if(gStatusbarMode) gToolbox = gStatusbar;

    initDialog();
}


removeToolboxListeners = function () {
    for(var i = 0; i < gToolboxes.length; i++) {
        gToolboxes[i].removeEventListener("dragstart", onToolbarDragStart, false);
        gToolboxes[i].removeEventListener("dragover", onToolbarDragOver, false);
        gToolboxes[i].removeEventListener("dragleave", onToolbarDragLeave, false);
        gToolboxes[i].removeEventListener("drop", onToolbarDrop, false);
        gToolboxes[i].customizing = false;
    }
}


/**
 * Persist the current set of buttons in all customizable toolbars to
 * localstore.
 */
//TODO: make reusable function
function persistCurrentSets() {

    // FX 3.6: vertikale Bookmarkleiste? => Attribut entfernen, um es dynamisch per CSS zu setzen
    if(aios_WIN.document.getElementById('bookmarksBarContent')) {
        for(var i = 0; i < aios_WIN.aios_toolbar.childNodes.length; i++){
            if(aios_WIN.aios_toolbar.childNodes[i].id == "personal-bookmarks") {
                aios_WIN.document.getElementById('bookmarksBarContent')._scrollbox.removeAttribute('orient');
            }
        }
    }

    if (!gToolboxChanged || gToolboxDocument.defaultView.closed)
        return;

    var docElt = gToolboxDocument.documentElement;

    for(var j = 0; j < gToolboxes.length; j++) {
        var toolbox = gToolboxes[j];
        var len = gStatusbarMode ? gToolboxes.length : gToolboxes[j].childNodes.length;

        var customCount = 0;
        var toolboxEmpty = true;
        for(var i = 0; i < len; ++i) {
            // Look for customizable toolbars that need to be persisted.  If toolbar
            // added but no buttons, arrays will not have it, so handle |i| node
            // undefined.
            var toolbar = gStatusbarMode ? toolbox :
            toolbox.childElementCount > 0 ? (toolbox.childNodes[i] ?
                toolbox.childNodes[i] : null) : null;
            if (isCustomizableToolbar(toolbar)) {
                // Calculate currentset and store it in the attribute.
                var currentSet = toolbar.currentSet;
                toolbar.setAttribute("currentset", currentSet);

                var customIndex = toolbar.hasAttribute("customindex");
                if (customIndex) {
                    if (!toolbar.firstChild) {
                        // Remove custom toolbars whose contents have been removed.
                        toolbox.removeChild(toolbar);
                        // Bump count since an item is gone.
                        i++;
                    }
                    else {
                        toolboxEmpty = false;
                        if (toolbox.toolbarset.hasAttribute('anonymous')) {
                            if (currentSet != "__empty") {
                                // Must persist xbl 'below-tabs' toolbar on the document root
                                var attrPrefix = '_toolbarset.' +
                                toolbox.toolbarset.getAttribute('id') + '.toolbar';
                                docElt.setAttribute(attrPrefix +
                                    (++customCount), toolbar.toolbarName + ":" + currentSet);
                                toolbar.setAttribute("customindex", customCount); //adjust count
                                gToolboxDocument.persist(docElt.id, attrPrefix+customCount);
                            }
                        }
                        else {
                            // Persist custom toolbar info on the <toolbarset/>
                            toolbox.toolbarset.setAttribute("toolbar" + (++customCount),
                                toolbar.toolbarName + ":" + currentSet);
                            toolbar.setAttribute("customindex", customCount); //adjust count
                            gToolboxDocument.persist(toolbox.toolbarset.id,
                                "toolbar" + customCount);
                        }
                    }
                }

                if (!customIndex) {
                    if (toolbar.firstChild) toolboxEmpty = false;
                    if (currentSet != "__empty" || toolbar.hasAttribute("defaultset")) {
                        if (toolbar.hasAttribute('anonymous')) {
                            // Must persist xbl tabbar toolbars on the document root
                            var attr = "_toolbar."+toolbar.getAttribute('id')+".currentset";
                            docElt.setAttribute(attr, currentSet);
                            gToolboxDocument.persist(gToolboxDocument.documentElement.id, attr);
                        }
                    }
                    else
                    if (!toolbar.hasAttribute("defaultset"))
                        toolbar.removeAttribute("currentset");
                    // Persist the currentset attribute directly on hardcoded toolbars.
                    gToolboxDocument.persist(toolbar.id, "currentset");
                }
            }
        }

        // Number of remaining toolbars in toolbox
        toolbox.customToolbarCount = customCount;
        setAttribute(toolbox, "empty", toolboxEmpty);
        gToolboxDocument.persist(toolbox.id, "empty");

        // Remove toolbarX attributes from toolbarset for removed toolbars, ie any
        // entries past those for toolbars already indexed..
        if (toolbox.toolbarset) {
            if (toolbox.toolbarset.hasAttribute('anonymous')) {
                var attrPrefix = '_toolbarset.' +
                toolbox.toolbarset.getAttribute('id') + '.toolbar';
                while (docElt.hasAttribute(attrPrefix+(++customCount))) {
                    docElt.removeAttribute(attrPrefix+customCount);
                    gToolboxDocument.persist(docElt.id, attrPrefix+customCount);
                }
            }
            else {
                while (toolbox.toolbarset.hasAttribute("toolbar"+(++customCount))) {
                    toolbox.toolbarset.removeAttribute("toolbar"+customCount);
                    gToolboxDocument.persist(toolbox.toolbarset.id, "toolbar"+customCount);
                }
            }
        }
    }
}


/**
 * Wraps all items in all customizable toolbars in a toolbox.
 */
wrapToolbarItems = function () {
    for(var j = 0; j < gToolboxes.length; j++) {
        var toolbox = gStatusbarMode ? {
            childNodes: [gToolboxes[0]]
            } : gToolboxes[j];
        var len = gToolboxes[j].childNodes.length;

        for(var i = 0; i < len; ++i) {
            var toolbar = toolbox.childNodes ? toolbox.childNodes[i] : null;
            if (isCustomizableToolbar(toolbar)) {
                for(var k = 0; k < toolbar.childNodes.length; ++k) {
                    var item = toolbar.childNodes[k];

                    // Bug 317062 fix for MacOS
                    if (item.firstChild && item.firstChild.localName == "menubar")
                        continue;

                    if (isToolbarItem(item)) {
                        var wrapper = wrapToolbarItem(item);
                        cleanupItemForToolbar(item, wrapper);
                    }
                }
            }
        }
    }
}


/**
 * Unwraps all items in all customizable toolbars in a toolbox.
 */
unwrapToolbarItems = function () {
    for(var j = 0; j < gToolboxes.length; j++) {
        var toolbox = gToolboxes[j];

        var paletteItems = toolbox.getElementsByTagName("toolbarpaletteitem");
        var paletteItem;
        while ((paletteItem = paletteItems.item(0)) != null) {
            var toolbarItem = paletteItem.firstChild;

            if (paletteItem.hasAttribute("itemdisabled"))
                toolbarItem.disabled = true;

            if (paletteItem.hasAttribute("itemcommand"))
                toolbarItem.setAttribute("command", paletteItem.getAttribute("itemcommand"));

            if (paletteItem.hasAttribute("itemhidden"))
                toolbarItem.hidden = true;

            if (paletteItem.hasAttribute("itemcollapsed"))
                toolbarItem.collapsed = true;

            // Remove label child from statusbarpanel item, if added..
            if (paletteItem.hasAttribute("itemlabelled")) {
                if (toolbarItem.className == "statusbarpanel-iconic-text")
                    toolbarItem.removeAttribute("label");
                else
                    toolbarItem.removeChild(toolbarItem.lastChild);
            }

            // Restore style if any, remove forced display
            toolbarItem.removeAttribute("style");
            if (paletteItem.hasAttribute("itemstyle"))
                toolbarItem.setAttribute("style", paletteItem.getAttribute("itemstyle"));

            paletteItem.parentNode.replaceChild(toolbarItem, paletteItem);
        }
    }

    if(gStatusbarMode)
        winDoc.getElementById("tt-statusbar-spacer").setAttribute("flex", 1);
}


/**
 * Restore the default set of buttons to fixed toolbars,
 * remove all custom toolbars, and rebuild the palette.
 */
restoreDefaultSet = function () {
    // Unwrap the items on the toolbar.
    unwrapToolbarItems();

    aios_WIN.aios_setToolbarPos(1);
    aios_WIN.aios_toolbar.setAttribute('flexbuttons', 'false');

    var docElt = gToolboxDocument.documentElement;

    for(var i = 0; i < gToolboxes.length; i++) {
        var toolbox = gToolboxes[i];

        if (!gStatusbarMode) {
            // Remove all of the customized toolbars.
            var child = toolbox.lastChild;
            while(child) {
                if (child.hasAttribute("customindex")) {

                    var thisChild = child;
                    child = child.previousSibling;
                    thisChild.currentSet = "__empty";
                    toolbox.removeChild(thisChild);
                } else {
                    child = child.previousSibling;
                }
            }
        }

        if(gStatusbarMode) {
            unwrapToolbarItems();
            tt_resetStatusbar();
        }
        else {
            // Restore the default icon size and mode - meaning Fx main toolbox if none
            var defaultMode = toolbox.hasAttribute("defaultmode") ?
            toolbox.getAttribute("defaultmode") :
            (navToolbox ? navToolbox.getAttribute("defaultmode") : null);
            var defaultIconsSmall = toolbox.hasAttribute("defaulticonsize") ?
            (toolbox.getAttribute("defaulticonsize") == "small" ?
                "small" : "large") :
            (navToolbox ? (navToolbox.getAttribute("defaulticonsize") == "small" ?
                "small" : "large") : "small");

            setAttribute(toolbox, "iconsize", defaultIconsSmall);
            gToolboxDocument.persist(toolbox.id, "iconsize");
            document.getElementById("smallicons").checked = defaultIconsSmall == "small";
            document.getElementById("smallicons").disabled = (defaultMode == "text" ? true : false);
            setAttribute(toolbox, "mode", defaultMode);
            gToolboxDocument.persist(toolbox.id, "mode");
            document.getElementById("modelist").value = defaultMode;

            // Restore the defaultset for fixed toolbars.
            var toolbar = toolbox.firstChild;
            while (toolbar) {
                if (isCustomizableToolbar(toolbar)) {
                    var defaultSet = toolbar.getAttribute("defaultset");
                    if (defaultSet || defaultSet == "")
                        toolbar.currentSet = defaultSet;
                    //Toolbox has custom binding, otherwise it's some other 3rd party toolbox
                    if (typeof toolbar.parentNode.setToolbarIconSize == "function")
                        toolbar.parentNode.setToolbarIconSize(toolbar, defaultIconsSmall);
                    else
                    if (toolbar.getAttribute("currentset") != "__empty") {
                        setAttribute(toolbar, "iconsize", defaultIconsSmall);
                        gToolboxDocument.persist(toolbar.id, "iconsize");
                    }

                    // Toolbox has custom binding, otherwise it's some other 3rd party toolbox
                    if (typeof toolbar.parentNode.setToolbarMode == "function")
                        toolbar.parentNode.setToolbarMode(toolbar, defaultMode);
                    else
                    if (toolbar.getAttribute("currentset") != "__empty") {
                        setAttribute(toolbar, "mode", defaultMode);
                        gToolboxDocument.persist(toolbar.id, "mode");
                    }
                }
                // Show nav-bar and bookmarks toolbar if hidden
                if (toolbar.id == "nav-bar" || toolbar.id == "PersonalToolbar")
                    toolbar.removeAttribute("collapsed");

                toolbar = toolbar.nextSibling;
            }
        }
    }

    // Now rebuild the palette.
    buildPalette();

    // Now re-wrap the items on the toolbar.
    wrapToolbarItems();

    toolboxChanged("reset");
}


updateIconSize = function (aUseSmallIcons, localDefault) {
    gToolboxIconSize = aUseSmallIcons ? "small" : "large";

    for(var j = 0; j < gToolboxes.length; j++) {
        var toolbox = gToolboxes[j];

        setAttribute(toolbox, "iconsize", gToolboxIconSize);
        gToolboxDocument.persist(toolbox.id, "iconsize");

        for(var i = 0; i < toolbox.childNodes.length; ++i) {
            var toolbar = toolbox.childNodes[i];
            if (isCustomizableToolbar(toolbar)) {
                //Toolbox has custom binding, otherwise it's some other 3rd party toolbox
                if (typeof toolbar.parentNode.setToolbarIconSize == "function")
                    toolbar.parentNode.setToolbarIconSize(toolbar, gToolboxIconSize);
                else {
                    var toolbarIconSize = (localDefault &&
                        toolbar.hasAttribute("defaulticonsize")) ?
                    toolbar.getAttribute("defaulticonsize") : gToolboxIconSize;
                    setAttribute(toolbar, "iconsize", toolbarIconSize);
                    gToolboxDocument.persist(toolbar.id, "iconsize");
                }
            }
        }
    }

    aios_WIN.aios_adjustToolboxWidth();
}


updateToolbarMode = function (aModeValue, localDefault) {

    for(var j = 0; j < gToolboxes.length; j++) {
        var toolbox = gToolboxes[j];

        setAttribute(toolbox, "mode", aModeValue);
        gToolboxDocument.persist(toolbox.id, "mode");

        for (var i = 0; i < toolbox.childNodes.length; ++i) {
            var toolbar = toolbox.childNodes[i];
            if (isCustomizableToolbar(toolbar)) {
                // Toolbox has custom binding, otherwise it's some other 3rd party toolbox
                if (typeof toolbar.parentNode.setToolbarMode == "function")
                    toolbar.parentNode.setToolbarMode(toolbar, aModeValue);
                else {
                    var toolbarMode = (localDefault &&
                        toolbar.hasAttribute("defaultmode")) ?
                    toolbar.getAttribute("defaultmode") : aModeValue;
                    setAttribute(toolbar, "mode", toolbarMode);
                    gToolboxDocument.persist(toolbar.id, "mode");
                }
            }
        }
    }

    var iconSizeCheckbox = document.getElementById("smallicons");
    iconSizeCheckbox.disabled = aModeValue == "text";

    aios_WIN.aios_adjustToolboxWidth();
}

function isCustomizableToolbar(aElt) {
    return (aElt) && ((aElt.localName == "toolbar" && aElt.getAttribute("customizable")) ||
        aElt.localName == "statusbar");
}


/**
 *  Breite der vertikalen Toolbar bei jeder Änderung der Toolbox (Drag 'n Drop) neu definieren
 **/
var fx_toolboxChanged = toolboxChanged;
toolboxChanged = function() {
    fx_toolboxChanged();
    aios_WIN.aios_adjustToolboxWidth();
};